function [nt, nadj] = aggregate(pt,plo,phi,pos1,pos2,pobs,  xt,xobs,xgrid,  nlag,nobs,ngrid,  L,U, vtomax) 


tol = 1e-12;

%% Reset policy  
 %(Recall, vtomax is value of the firm to be 
 % maximized in event the firm adjusts.
 % It is xobs x pobs x Nobs by nobs)
 % First, Interpolate across p for all (x,n):
ros1  = (1 + (pos1-1)*xobs: pos1*xobs)';
ros2  = (1 + (pos2-1)*xobs: pos2*xobs)';
vt    = vtomax(ros1,:) + ((pt-plo)/(phi-plo + tol))*( vtomax(ros2,:) -vtomax(ros1,:));
 % Then, Evaluate vt @ simulated xs
vtfit   = spline( xgrid,vt', xt'); % should be nobs x N.
 % And, maximize:
[~,pos] = max( vtfit );
nadj    = ngrid(pos);


%% Triggers
 % Triggers are a function of p, n_-1. 
 % Interpolate at p for all n_-1.
 % Triggers are ~ log linear, so 
 % use linear interpolation.
Ln1   = exp(interp1( log(ngrid), log(L(:,pos1)), log(nlag),'linear'));
Ln2   = exp(interp1( log(ngrid), log(L(:,pos2)), log(nlag),'linear'));
Lfit  = Ln1 + ((pt-plo)/(phi-plo + tol))*( Ln2-Ln1);

Un1   = exp(interp1( log(ngrid), log(U(:,pos1)), log(nlag),'linear'));
Un2   = exp(interp1( log(ngrid), log(U(:,pos2)), log(nlag),'linear'));
Ufit  = Un1 + ((pt-plo)/(phi-plo + tol))*( Un2-Un1);


%% Choose n:
noadjust = (Lfit<=xt).*(xt<=Ufit);
nt   = nlag.*noadjust + nadj.*(1-noadjust);
