function [L,U] = triggers(nobs,xobs,xgrid,pobs,  v_no,v_adj)


vMAT_no = reshape(v_no,  xobs,pobs, nobs);
vMAT_adj= reshape(v_adj, xobs,pobs);

U = zeros(nobs,pobs);
L = zeros(nobs,pobs);
parfor i = 1:pobs % p(t)

    for j = 1:nobs %n(t)
        vj_no = vMAT_no( :, i,j);
        vj_adj= vMAT_adj(:, i);
        Delta = vj_adj - vj_no; %Net value of adjusting.
        [Dstar, pos] =  min(Delta);

        if pos>1 && pos<xobs
            Dspl          = spline( xgrid, Delta );
            [Dmin,argmin] = fnmin( Dspl );
            if Dmin <0
                if      Delta(1)>0 && Delta(xobs)>0
                    Dfunc  = spline( xgrid, Delta );
                    trig   = unique(fnzeros(Dfunc));
                    L(j,i) = trig(1);
                    U(j,i) = trig(2);

                elseif  Delta(1)>0 && Delta(xobs)<0 %% do not see HIRE trigger
                    Dfunc  = spline( xgrid(1:pos), Delta(1:pos) );
                    trig   = unique(fnzeros(Dfunc));
                    L(j,i) = trig(1);
                    U(j,i) = xgrid(xobs);

                elseif  Delta(1)<0 && Delta(xobs)>0 %% do not see FIRE trigger
                    Dfunc  = spline( xgrid(pos:xobs), Delta(pos:xobs) );
                    trig   = unique(fnzeros(Dfunc));
                    L(j,i) = xgrid(1);
                    U(j,i) = trig(1);

                elseif  Delta(1)<0 && Delta(xobs)<0 %% do not see either trigger
                    L(j,i) = xgrid(1);
                    U(j,i) = xgrid(xobs);
                end

            else
                disp('Error: Interior minimum of V*-V0 is positive.');
                pause;
            end 
        end

        if pos == 1
            if      Delta(1)<0 && Delta(xobs)>0 %% do not see FIRE trigger
                Dfunc = spline( xgrid, Delta );
                trig  = unique(fnzeros(Dfunc));
                L(j,i) = xgrid(1);
                U(j,i) = trig(1);
            elseif  Delta(1)<0 && Delta(xobs)<0 %% do not see either trigger
                L(j,i) = xgrid(1);
                U(j,i) = xgrid(xobs);
            elseif  Delta(1)>0 && Delta(xobs)>0 %% do not see either trigger
                L(j,i) = xgrid(1); %if value of HIRE is everywhere greater, 
                U(j,i) = xgrid(1); %then HIRE all of the time.
            end
        end

        if pos == xobs
            if      Delta(1)>0 && Delta(xobs)<0 %% do not see HIRE trigger
                Dfunc = spline( xgrid, Delta );
                trig  = unique(fnzeros(Dfunc));
                L(j,i) = trig(1);
                U(j,i) = xgrid(xobs);
            elseif  Delta(1)<0 && Delta(xobs)<0 %% do not see either trigger
                L(j,i) = xgrid(1);
                U(j,i) = xgrid(xobs);
            elseif  Delta(1)>0 && Delta(xobs)>0 %% value of FIRE is everywhere greater
                L(j,i) = xgrid(xobs);
                U(j,i) = xgrid(xobs);
            end
        end

    end
end
