function [nt, nadj] = fixedptN(pt,plo,phi,pos1,pos2,pobs,  Nlag,Nobs,Nvec,  xt,xobs,xgrid,  nlag,nobs,ngrid,  L,U, vtomax) 



Nt  = Nlag;
Ntol= .001;
Nres=  1;
Niter= 1;
Nstep= 1/5;
tol  = 1e-8;
    
while Nres >Ntol  
    Npos2= find( Nvec >Nt,1,'first');
    if isempty(Npos2) ==1
        Npos1 = Nobs-1;
        Npos2 = Nobs;
    else
        Npos1 = Npos2-1;
    end
    Nlo = Nvec(Npos1);
    Nhi = Nvec(Npos2);

    Pos11 = (pos1-1)*xobs + (Npos1-1)*pobs*xobs;
    Pos21 = (pos2-1)*xobs + (Npos1-1)*pobs*xobs;
    Pos12 = (pos1-1)*xobs + (Npos2-1)*pobs*xobs;
    Pos22 = (pos2-1)*xobs + (Npos2-1)*pobs*xobs;
    ros11 = (1 + Pos11: xobs +Pos11)';
    ros21 = (1 + Pos21: xobs +Pos21)';
    ros12 = (1 + Pos12: xobs +Pos12)';
    ros22 = (1 + Pos22: xobs +Pos22)';

    %% Reset policy  (Recall, vtomax is value of the firm to be 
     % maximized in event the firm adjusts.
     % It is xobs x pobs x Nobs by nobs)
     % First, interpolate across p given N and for all (x,n):
    vtomax1 = vtomax(ros11,:) + ((pt-plo)/(phi-plo + tol))*( vtomax(ros21,:) -vtomax(ros11,:));
    vtomax2 = vtomax(ros12,:) + ((pt-plo)/(phi-plo + tol))*( vtomax(ros22,:) -vtomax(ros12,:));
     % Then, interpolate across N:
    vt      = vtomax1 + ((Nt-Nlo)/(Nhi-Nlo + tol))*( vtomax2-vtomax1); %xobs by nobs.
     % Evaluate vt @ simulated xs
    vtfit   = spline( xgrid,vt', xt'); % should be nobs x N.
     % And, maximize:
    [~,pos] = max( vtfit );
    nadj    = ngrid(pos);


    %% Triggers
     % Triggers are a function of p,N, n_-1. 
     % Interpolate at (p,N) for all n_-1.
     % Triggers are ~ log linear, so 
     % use linear interpolation.
    ros11 = pos1 + (Npos1-1)*pobs;
    ros21 = pos2 + (Npos1-1)*pobs;
    ros12 = pos1 + (Npos2-1)*pobs;
    ros22 = pos2 + (Npos2-1)*pobs;

    Ln11  = exp(interp1( log(ngrid), log(L(:,ros11)), log(nlag),'linear'));
    Ln21  = exp(interp1( log(ngrid), log(L(:,ros21)), log(nlag),'linear'));
    Ln12  = exp(interp1( log(ngrid), log(L(:,ros12)), log(nlag),'linear'));
    Ln22  = exp(interp1( log(ngrid), log(L(:,ros22)), log(nlag),'linear'));
    Ln1   = Ln11 + ((pt-plo)/(phi-plo + tol))*( Ln21-Ln11);
    Ln2   = Ln12 + ((pt-plo)/(phi-plo + tol))*( Ln22-Ln12);
    Lfit  = Ln1  + ((Nt-Nlo)/(Nhi-Nlo + tol))*( Ln2-Ln1);             

    Un11  = exp(interp1( log(ngrid), log(U(:,ros11)), log(nlag),'linear'));
    Un21  = exp(interp1( log(ngrid), log(U(:,ros21)), log(nlag),'linear'));
    Un12  = exp(interp1( log(ngrid), log(U(:,ros12)), log(nlag),'linear'));
    Un22  = exp(interp1( log(ngrid), log(U(:,ros22)), log(nlag),'linear'));
    Un1   = Un11 + ((pt-plo)/(phi-plo + tol))*( Un21-Un11);
    Un2   = Un12 + ((pt-plo)/(phi-plo + tol))*( Un22-Un12);
    Ufit  = Un1  + ((Nt-Nlo)/(Nhi-Nlo + tol))*( Un2-Un1); 

     %% Choose n:
    noadjust = (Lfit<=xt).*(xt<=Ufit);
    nt   = nlag.*noadjust + nadj.*(1-noadjust);
    Nt_  = mean(nt);
    Nres = abs(Nt - Nt_);
    Nt   = Nt - Nstep*(Nt - Nt_); % if conjecture > solution, then wage is too high, need to reduce Nt (and thus Wt).
    if Niter/15 ==floor(Niter/15); disp('WARNING: Excessive iterations on N fixed point, Lower step size'); Nstep = Nstep/2; end 
   %disp( [Niter,Nres] ); pause;
    Niter= Niter +1;
end 
