function EV = evfunlinear(nobs,xobs,xgrid,ngrid,xweights,  pobs,pgrid,Ptrans,  nf,nh,v_no,v_adjh,v_adjf,  mux,rhox,Stdev_epsx)


EV     = zeros(xobs*pobs,nobs);
parfor h  = 1:nobs; %n(t)
    Ev    = zeros( xobs, pobs);
    
    for i = 1:xobs; %x(t+1)
        ros  = (i  :xobs: xobs*(pobs-1) + i)';
        
        vj_no   = v_no(ros, h);
        vj_adjh = v_adjh(ros, h);
        vj_adjf = v_adjf(ros, h);
        indxh   = (ngrid(h)< nh(i,:)' );
        indxf   = (nf(i,:)' < ngrid(h));
        Vj_adjh = vj_adjh.*indxh  - 10e4*(1-indxh);
        Vj_adjf = vj_adjf.*indxf  - 10e4*(1-indxf);
        V       = max( [vj_no,Vj_adjh,Vj_adjf],[],2 );  
            
        ev      = Ptrans*V; %pobs by 1;
        Ev(i,:) = ev';
    end
    xnext  = ones(xobs,1)*xgrid';
    xnow   = xgrid       *ones(1,xobs);
    elogx  = mux + rhox*log(xnow);
    Fxmax  = normcdf((log(xgrid(xobs))-elogx)/Stdev_epsx);
    Fxmin  = normcdf((log(xgrid(1   ))-elogx)/Stdev_epsx);
    pdfx   = (1./(xnext*Stdev_epsx*sqrt(2*pi))) .* exp(-0.5*( ((log(xnext)   -elogx)/Stdev_epsx).^2 ));
    pdfx   = pdfx ./ (Fxmax -Fxmin);
    xwght  = ones(xobs,1)*xweights';
    Pdfx   = xwght .* pdfx;
    ev     = Pdfx*Ev;
    EV(:,h) = reshape( ev,xobs*pobs,1);
end