function [nhatsim,fbdensity,nt,ht] = flowbalance_size(nsim,nlag)

%First, discard above 1000 in either nsim or nlag
ros1000c = find(nsim >= 1000);
ros1000l = find(nlag >= 1000);
%create union of ros1000 and ros1000l
ros1000 = union(ros1000c,ros1000l);
%eliminate
nsim(ros1000) = [];
nlag(ros1000) = [];
N = length(nsim);

nbinl  = (1:1:1000)';
nbinr  = (1:1:1000)';
nbins = (nbinr+nbinl)./2;
bins = length(nbinl);


ht = zeros(bins,1);
hlag = zeros(bins,1);
adjfrom = zeros(bins,1);
for j = 1:bins
    posn = find((nsim>=nbinl(j)).*(nsim<=nbinr(j)));
    if isempty(posn)==1; obs = 0; else obs = length(posn); end
    ht(j) = obs/N;
    
    % outflows %%%%%%%%%%
    posn = find((nlag>=nbinl(j)).*(nlag<=nbinr(j)));
    if isempty(posn)==1; obs = 0; else obs = length(posn); end
    hlag(j) = obs/N;
    
    if isempty(posn)==0
         % if there is mass at n_-1, 
        posl = find( nsim(posn)< nbinl(j));
        posr = find( nsim(posn)> nbinr(j));
        adjfrom(j) = (length(posl)+length(posr)) /length(posn);
    end        

end
%Eliminate zeros
posdrop1 = find( hlag >0,1,'first');
posdrop2 = find( hlag >0,1,'last' );
if posdrop1 ==1;    posdrop1 = []; end
if posdrop2 ==bins; posdrop2 = []; end
posdrop  = [(1:posdrop1-1)';  (posdrop2+1:bins)'];
nt = nbins;
nt(posdrop,:) =[];
ht(posdrop,:) =[];
hlag(posdrop,:) =[];
adjfrom(posdrop,:) =[];
ht   = ht/sum(ht);
hlag = hlag/sum(hlag);

% Because of finite sample, prob(adj from n) 
% may be zero Even if there IS mass
% there.  In this case, we IMPUTE.

bins= length(nt);
k = 1;
while k <= bins
    if adjfrom(k) ==0
        if k ==1
            apos = find( adjfrom >0,1,'first');
            adjfrom(k:apos) = adjfrom(apos);
            k = apos;
        elseif k ==bins
            apos = find( adjfrom >0,1,'last');
            adjfrom(k) = adjfrom(apos);
            k = k + 1; 
        else
             % catch other adjacent zeros
             % We do this so we can then (see below)
             % interpolate between two points where
             % prob(adj) is >0.
            stop =0;
            kk =0;
            while stop ==0
                stop = (adjfrom(k+1+kk) >0);
                if stop ==0 && k+1+kk < bins
                    kk = kk +1;
                elseif stop ==0 && k+1+kk ==bins
                    stop = 1;
                end
            end
            if k+1+kk ==bins
                adjfrom(k:end) = adjfrom(k-1);
            else
                 % this linearly interpolates the zeros.
                 % (note - if k is the only zero, then kk=0)
                 adjfrom(k:k+kk) = adjfrom(k-1) + ((adjfrom(k+1+kk) - adjfrom(k-1))./(nbins(k+1+kk)-nbins(k-1))).*(nbins(k:k+kk) - nbins(k-1));
            end
            k = k + 1 +kk;
        end
    else
        k = k + 1;
    end
end

%Invert law of motion
fbdensity = hlag + ((ht-hlag)./adjfrom);
nhatsim   = nt'*fbdensity; 










    
