function [L,U] = triggersks(nobs,xobs,xgrid,pobs,Nobs,  v_no,v_adj)


vMAT_no = reshape(v_no,  xobs,pobs,Nobs, nobs);
vMAT_adj= reshape(v_adj, xobs,pobs,Nobs);

U = zeros(nobs,pobs,Nobs);
L = zeros(nobs,pobs,Nobs);
parfor h = 1:Nobs % N(t)
    for i = 1:pobs % p(t)
        
        for j = 1:nobs %n(t)
            vj_no = vMAT_no( :, i,h,j);
            vj_adj= vMAT_adj(:, i,h);
            Delta = vj_adj - vj_no; %Net value of adjusting.
            [Dstar, pos] =  min(Delta);

            if pos>1 && pos<xobs
                Dspl          = spline( xgrid, Delta );
                [Dmin,argmin] = fnmin( Dspl );
                if Dmin <0
                    if      Delta(1)>0 && Delta(xobs)>0
                        Dfunc  = spline( xgrid, Delta );
                        trig   = unique(fnzeros(Dfunc));
                        L(j,i,h) = trig(1);
                        U(j,i,h) = trig(2);

                    elseif  Delta(1)>0 && Delta(xobs)<0 %% do not see HIRE trigger
                        Dfunc  = spline( xgrid(1:pos), Delta(1:pos) );
                        trig   = unique(fnzeros(Dfunc));
                        L(j,i,h) = trig(1);
                        U(j,i,h) = xgrid(xobs);

                    elseif  Delta(1)<0 && Delta(xobs)>0 %% do not see FIRE trigger
                        Dfunc  = spline( xgrid(pos:xobs), Delta(pos:xobs) );
                        trig   = unique(fnzeros(Dfunc));
                        L(j,i,h) = xgrid(1);
                        U(j,i,h) = trig(1);

                    elseif  Delta(1)<0 && Delta(xobs)<0 %% do not see either trigger
                        L(j,i,h) = xgrid(1);
                        U(j,i,h) = xgrid(xobs);
                    end
                
                else
                    disp('Error: Interior minimum of V*-V0 is positive.');
                    pause;
                end 
            end

            if pos == 1
                if      Delta(1)<0 && Delta(xobs)>0 %% do not see FIRE trigger
                    Dfunc = spline( xgrid, Delta );
                    trig  = unique(fnzeros(Dfunc));
                    L(j,i,h) = xgrid(1);
                    U(j,i,h) = trig(1);
                elseif  Delta(1)<0 && Delta(xobs)<0 %% do not see either trigger
                    L(j,i,h) = xgrid(1);
                    U(j,i,h) = xgrid(xobs);
                elseif  Delta(1)>0 && Delta(xobs)>0 %% do not see either trigger
                    L(j,i,h) = xgrid(1); %if value of HIRE is everywhere greater, 
                    U(j,i,h) = xgrid(1); %then HIRE all of the time.
                end
            end

            if pos == xobs
                if      Delta(1)>0 && Delta(xobs)<0 %% do not see HIRE trigger
                    Dfunc = spline( xgrid, Delta );
                    trig  = unique(fnzeros(Dfunc));
                    L(j,i,h) = trig(1);
                    U(j,i,h) = xgrid(xobs);
                elseif  Delta(1)<0 && Delta(xobs)<0 %% do not see either trigger
                    L(j,i,h) = xgrid(1);
                    U(j,i,h) = xgrid(xobs);
                elseif  Delta(1)>0 && Delta(xobs)>0 %% value of FIRE is everywhere greater
                    L(j,i,h) = xgrid(xobs);
                    U(j,i,h) = xgrid(xobs);
                end
            end

        end
    end
    %disp(h);
end