function nt = fixedptN(pt,plo,phi,pos1,pos2,pobs,  Nlag,Nobs,Nvec,  xt,xobs,xgrid,  nlag,nobs,ngrid,  vtomaxh, vtomaxf)


Nt  = Nlag;
Ntol= .001;
Nres=  1;
Niter= 1;
Nstep= 1/3;
tol  = 1e-12;
    
while Nres >Ntol  
    Npos2= find( Nvec >Nt,1,'first');
    if isempty(Npos2) ==1
        Npos1 = Nobs-1;
        Npos2 = Nobs;
    else
        Npos1 = Npos2-1;
    end
    Nlo = Nvec(Npos1);
    Nhi = Nvec(Npos2);

    Pos11 = (pos1-1)*xobs + (Npos1-1)*pobs*xobs;
    Pos21 = (pos2-1)*xobs + (Npos1-1)*pobs*xobs;
    Pos12 = (pos1-1)*xobs + (Npos2-1)*pobs*xobs;
    Pos22 = (pos2-1)*xobs + (Npos2-1)*pobs*xobs;
    ros11 = (1 + Pos11: xobs +Pos11)';
    ros21 = (1 + Pos21: xobs +Pos21)';
    ros12 = (1 + Pos12: xobs +Pos12)';
    ros22 = (1 + Pos22: xobs +Pos22)';

    %% Reset policy  (Recall, vtomax is value of the firm to be 
     % maximized in event the firm adjusts.
     % It is xobs x pobs x Nobs by nobs)
     
     % HIRING
    vtomax = vtomaxh;     
     % First, interpolate across p given N and for all (x,n):
    vtomax1 = vtomax(ros11,:) + ((pt-plo)/(phi-plo + tol))*( vtomax(ros21,:) -vtomax(ros11,:));
    vtomax2 = vtomax(ros12,:) + ((pt-plo)/(phi-plo + tol))*( vtomax(ros22,:) -vtomax(ros12,:));
     % Then, interpolate across N:
    vt      = vtomax1 + ((Nt-Nlo)/(Nhi-Nlo + tol))*( vtomax2-vtomax1); %xobs by nobs.
     % Evaluate vt @ simulated xs
    vtfit   = spline( xgrid,vt', xt'); % should be nobs x N.
     % And, maximize:
    [~,pos] = max( vtfit );
    nhire   = ngrid(pos);
    
     % FIRING
    vtomax  = vtomaxf;     
     % First, interpolate across p given N and for all (x,n):
    vtomax1 = vtomax(ros11,:) + ((pt-plo)/(phi-plo + tol))*( vtomax(ros21,:) -vtomax(ros11,:));
    vtomax2 = vtomax(ros12,:) + ((pt-plo)/(phi-plo + tol))*( vtomax(ros22,:) -vtomax(ros12,:));
     % Then, interpolate across N:
    vt      = vtomax1 + ((Nt-Nlo)/(Nhi-Nlo + tol))*( vtomax2-vtomax1); %xobs by nobs.
     % Evaluate vt @ simulated xs
    vtfit   = spline( xgrid,vt', xt'); % should be nobs x N.
     % And, maximize:
    [~,pos] = max( vtfit );
    nfire   = ngrid(pos);


     %% Choose n:
    nt   = nlag.*(nhire<=nlag).*(nlag<=nfire) + nhire.*(nlag<nhire) + nfire.*(nlag>nfire);
    Nt_  = mean(nt);
    Nres = abs(Nt - Nt_);
    Nt   = Nt - Nstep*(Nt - Nt_); % if conjecture > solution, then wage is too high, need to reduce Nt (and thus Wt).
    if Niter/15 ==floor(Niter/15); disp('WARNING: Excessive iterations on N fixed point, Lower step size'); Nstep = Nstep/2; end 
   %disp( [Niter,Nres] ); 
    Niter= Niter +1;
end 
