function [Thetat_fin, Nt_fin, hnew_xn] = Ninnerloop( Ntin,Thetat,Fillt,   Thvec,Thobs,Nvec,Nobs,L0,  vhfitp,vffitp,Xhfitp,Xffitp,  xobs2,xobs,nobs,  xgrid2,xgrid,ngrid,   transxmat2,h_xn)


tol = 1e-12;
% Interpolate value functions @ Theta(t).
Thpos2= find( Thvec >Thetat,1,'first');
if isempty(Thpos2) ==1
    Thpos1 = Thobs -1;
    Thpos2 = Thobs;
else
    Thpos1 = max(1,Thpos2-1);
end
Thlo = Thvec(Thpos1);
Thhi = Thvec(Thpos2);
vh_T1= reshape( vhfitp(:,Thpos1,:,:), xobs,Nobs,nobs);
vh_T2= reshape( vhfitp(:,Thpos2,:,:), xobs,Nobs,nobs);
vf_T1= reshape( vffitp(:,Thpos1,:,:), xobs,Nobs,nobs);
vf_T2= reshape( vffitp(:,Thpos2,:,:), xobs,Nobs,nobs);
vhfitpT = vh_T1 + ((Thetat-Thlo)/(Thhi-Thlo +tol))*( vh_T2 -vh_T1);
vffitpT = vf_T1 + ((Thetat-Thlo)/(Thhi-Thlo +tol))*( vf_T2 -vf_T1);   

% and thresholds:
Xh_T1= reshape( Xhfitp(:,Thpos1,:), nobs, Nobs);
Xh_T2= reshape( Xhfitp(:,Thpos2,:), nobs, Nobs);
Xf_T1= reshape( Xffitp(:,Thpos1,:), nobs, Nobs);
Xf_T2= reshape( Xffitp(:,Thpos2,:), nobs, Nobs);
XhfitpT = Xh_T1 + ((Thetat-Thlo)/(Thhi-Thlo +tol))*( Xh_T2 -Xh_T1);
XffitpT = Xf_T1 + ((Thetat-Thlo)/(Thhi-Thlo +tol))*( Xf_T2 -Xf_T1);   



%% Solve for Aggregate Employment, given tightness Thetat
Ntin0 = Ntin;
dN    = 1;
dNtol = .001;
dNiter    =  1;
dNitermax = 50;
Nstep =  1/3;
dnNEG = -100;
dnPOS =  100;
while dN > dNtol && dNiter <=dNitermax
    [~,~,~,Ntout] = aggregateN( Ntin,Nvec,Nobs, vhfitpT,vffitpT,XhfitpT,XffitpT,  xobs,xobs2,nobs,  xgrid,xgrid2,ngrid,   transxmat2,h_xn);
    dn = Ntout - Ntin;
    dN = abs(dn);
    %disp( [Ntin, Ntout] ); pause;
    
    Ntin = Ntin + Nstep*(Ntout - Ntin);
    
     % Sometimes, algorithm can 'skip over' fixed point.
     % In that case, linearly interpolate across 
     % 2 values that surround dn=0.
    if dn >0
        dnPOS = min( [dn, dnPOS] );
        ntPOS = Ntin;
    elseif dn <0
        dnNEG = max( [dn, dnNEG] );
        ntNEG = Ntin;
    end
   %disp( [dnPOS, dnNEG] ); 
    
    dNiter = dNiter + 1;
end

if dNiter >=dNitermax
    disp('Reached max iterations for N fixed point'); %pause;
    y1 = dnNEG;
    y2 = dnPOS;
    x1 = ntNEG;
    x2 = ntPOS;
    % 0= y1 + ((n* - x1)/(x2-x1)) *( y2 - y1) -->
    Nt_fin = x1 - ((x2-x1)*y1/(y2-y1+tol));
else
    Nt_fin = Ntout;
end

% Now, get the flows consistent with Nt_fin
[~,Hires,hnew_xn,~] = aggregateN( Nt_fin,Nvec,Nobs, vhfitpT,vffitpT,XhfitpT,XffitpT,  xobs,xobs2,nobs,  xgrid,xgrid2,ngrid,   transxmat2,h_xn);
Unemploy  = L0 - Nt_fin;
Vacancies = Hires/Fillt;
Thetat_fin= Vacancies /Unemploy;
   

    



