function [Thetat, Nt, ht_xn] = Thetaouterloop(Ntin, Thetatin, Thvec,Thobs,Nvec,Nobs,L0,  vhfitp,vffitp,Xhfitp,Xffitp,  xobs2,xobs,nobs, xgrid2,xgrid,ngrid,  transxmat2,h_xn,  mcons,felas)



%% Solve for Market Tightness
Thetatin0 = Thetatin;
dTh    = 1;
dThtol = .001;
dThiter    =  1;
dThitermax = 100;
Thstep =  1/3;
dThNEG = -100;
dThPOS =  100;
while dTh > dThtol && dThiter <=dThitermax
    
    Fillrate  = mcons*( Thetatin^(felas-1));
    [Thetatout,Ntout,htout_xn] = Ninnerloop(Ntin,Thetatin,Fillrate,   Thvec,Thobs,Nvec,Nobs,L0,  vhfitp,vffitp,Xhfitp,Xffitp,  xobs2,xobs,nobs,  xgrid2,xgrid,ngrid,  transxmat2,h_xn);
    % Ninnerloop solves fixed point problem for aggregate N given Thetatin.
    % Thetatout is tightness implied by solution for N.
    
    dth = Thetatout - Thetatin;
   %disp( [Thetatin, Thetatout] ); pause;
    Thetatin = Thetatin + Thstep*(Thetatout - Thetatin);

     % Sometimes, algorithm can 'skip over' fixed point.
     % In that case, linearly interpolate across  
     % 2 values that surround dth=0.
    if dth >0
        dThPOS = min( [dth, dThPOS] );
        ThPOS  = Thetatin;
    elseif dth <0
        dThNEG = max( [dth, dThNEG] );
        ThNEG  = Thetatin;
    end

    dTh = abs(dth);
    dThiter  = dThiter + 1;
end

if dThiter >=dThitermax
    disp('Reached max iterations for Theta fixed point');
    y1 = dThNEG;
    y2 = dThPOS;
    x1 = ThNEG;
    x2 = ThPOS;
    tol= 1e-12;
    % 0= y1 + ((n* - x1)/(x2-x1)) *( y2 - y1) -->
    Thetat = x1 - ((x2-x1)*y1/(y2-y1+tol));
    disp( [ThNEG, Thetat, ThPOS] );
    disp( [dThNEG, dThPOS] );
   %pause;
    
    Fillrate = mcons*( Thetat^(felas-1));
    [~,Nt,ht_xn] = Ninnerloop(Ntin,Thetat,Fillrate,   Thvec,Thobs,Nvec,Nobs,L0,  vhfitp,vffitp,Xhfitp,Xffitp,  xobs2,xobs,nobs,  xgrid2,xgrid,ngrid,  transxmat2,h_xn);
    
else
    Thetat = Thetatout;
    ht_xn = htout_xn;
    Nt = Ntout;
end


