function [Seps,Hires,hnew_xn,Nt] = aggregateN( Nt,Nvec,Nobs, vhfitpT,vffitpT,XhfitpT,XffitpT,  xobs,xobs2,nobs,  xgrid,xgrid2,ngrid,   transxmat2, h_xn)


 %% Interpolate @ N(t).
Npos2= find( Nvec >Nt,1,'first');
if isempty(Npos2) ==1
    Npos1 = Nobs -1;
    Npos2 = Nobs;
else
    Npos1 = Npos2-1;
end
Nlo = Nvec(Npos1);
Nhi = Nvec(Npos2);
 % value functions 
vh_N1 = reshape(vhfitpT(:,Npos1,:), xobs,nobs);
vh_N2 = reshape(vhfitpT(:,Npos2,:), xobs,nobs);
vf_N1 = reshape(vffitpT(:,Npos1,:), xobs,nobs);
vf_N2 = reshape(vffitpT(:,Npos2,:), xobs,nobs);
vhfit = vh_N1 + ((Nt-Nlo)/(Nhi-Nlo))*( vh_N2 -vh_N1); % xobs by nobs.
vffit = vf_N1 + ((Nt-Nlo)/(Nhi-Nlo))*( vf_N2 -vf_N1);

 % thresholds
Xh_N1 = XhfitpT(:,Npos1);
Xh_N2 = XhfitpT(:,Npos2);
Xf_N1 = XffitpT(:,Npos1);
Xf_N2 = XffitpT(:,Npos2);
Xhfit = Xh_N1 + ((Nt-Nlo)/(Nhi-Nlo))*( Xh_N2 -Xh_N1);
Xffit = Xf_N1 + ((Nt-Nlo)/(Nhi-Nlo))*( Xf_N2 -Xf_N1);



 %% Fit policy rules to Enlarged productivity grid.
vhfit2 = spline(xgrid', vhfit', xgrid2); %nobs by xobs2.
vffit2 = spline(xgrid', vffit', xgrid2);
[~,posh] =  max(vhfit2); 
[~,posf] =  max(vffit2); 
nht  = ngrid(posh);
nft  = ngrid(posf);

[~,hro] = min(abs( ngrid*ones(1,xobs2) -ones(nobs,1)*nht')); %this finds element of ngrid that matches each nht
[~,fro] = min(abs( ngrid*ones(1,xobs2) -ones(nobs,1)*nft'));
hro = hro'; % xobs2 by 1
fro = fro';



 %% Simulate joint distribution
[Nt,Seps,Hires, hnew_xn, ~] = jointxn(xobs2,xgrid2,nobs,ngrid,  transxmat2,  h_xn,  Xhfit,Xffit, nht,nft, hro,fro);
    
            