function EV = evsearch(nobs,ngrid,  xobs,xgrid,xweights,mux,rhox,Stdev_epsx,  pobs,pgrid,Ptrans,  vprime, Nvec,Nobs,NOLScons,NOLSlag,NOLSp, Thvec,Thobs,ThOLScons,ThOLSn,ThOLSp)



 % Transition matrix (for below)
xnext  = ones(xobs,1)*xgrid';
xnow   = xgrid       *ones(1,xobs);
elogx  = mux + rhox*log(xnow);
Fxmax  = normcdf((log(xgrid(xobs))-elogx)/Stdev_epsx);
Fxmin  = normcdf((log(xgrid(1   ))-elogx)/Stdev_epsx);
pdfx   = (1./(xnext*Stdev_epsx*sqrt(2*pi))) .* exp(-0.5*( ((log(xnext)   -elogx)/Stdev_epsx).^2 ));
pdfx   = pdfx ./ (Fxmax -Fxmin);
xwght  = ones(xobs,1)*xweights';
Pdfx   = xwght .* pdfx;
Sumpdfx= sum(Pdfx, 2);
Pdfx   = Pdfx ./ repmat(Sumpdfx, 1, xobs);


 % Reshape value functions -
Vprime   = reshape(vprime, xobs,pobs,Thobs,Nobs, nobs);

 % Grids -
pVEC  = repmat(pgrid,Nobs, 1);
NVEC  = kron(Nvec,  ones(pobs,1));


tol    = 1e-8;
EV     = zeros(xobs*pobs*Thobs*Nobs, nobs);
parfor h  = 1:nobs %n(t)
    
    Ev = zeros( xobs, pobs*Thobs*Nobs);
    for i = 1:xobs %x(t+1)
        V      = reshape(Vprime(  i,:,:,:,h), pobs, Thobs*Nobs); % V(p', Theta', N')
         
         % Interpolate forward value function, V, at Theta'(p',N') and N'(p',N) 
        Nprime  = exp( NOLScons  + NOLSlag*log(NVEC)   + NOLSp* log(pVEC) );    %pobs (p') x Nobs (N) by 1
        Thprime = exp( ThOLScons + ThOLSn *log(Nprime) + ThOLSp*log(pVEC) );
        dN    = Nvec*ones(1,pobs*Nobs)  -ones(Nobs,1)*Nprime';
        [~,pos2] = max( dN.*(dN<=0) );
        npos2 = max( 2,pos2');
        npos1 = npos2 -1;
        Nlo   = Nvec( npos1);
        Nhi   = Nvec( npos2);
        dTh   = Thvec*ones(1,pobs*Nobs) -ones(Thobs,1)*Thprime';
        [~,pos2] = max( dTh.*(dTh<=0) );
        tpos2 = max( 2,pos2');
        tpos1 = tpos2 -1;
        Thlo = Thvec( tpos1);
        Thhi = Thvec( tpos2);
            
        cols11= tpos1 +Thobs*(npos1-1);
        cols21= tpos2 +Thobs*(npos1-1);
        cols12= tpos1 +Thobs*(npos2-1);
        cols22= tpos2 +Thobs*(npos2-1);            
        V11   = V( repmat((1:pobs)',Nobs,1) + (cols11-1)*pobs);
        V21   = V( repmat((1:pobs)',Nobs,1) + (cols21-1)*pobs);
        V12   = V( repmat((1:pobs)',Nobs,1) + (cols12-1)*pobs);
        V22   = V( repmat((1:pobs)',Nobs,1) + (cols22-1)*pobs);
        
        vfit1 = V11 + ((Thprime-Thlo)./(Thhi-Thlo +tol)).*( V21 -V11); 
        vfit2 = V12 + ((Thprime-Thlo)./(Thhi-Thlo +tol)).*( V22 -V12);
        vfit  = vfit1 +((Nprime-Nlo)./(Nhi-Nlo +tol)).*( vfit2 - vfit1); % a function of p(t+1), N(t).
        Vfit  = reshape(vfit, pobs, Nobs);
        
        ev      = Ptrans*Vfit; % pobs by Nobs;
        ev_     = repmat(  ev, Thobs, 1); % add filler for Theta(t)
        ev_     = reshape( ev_, pobs*Thobs*Nobs, 1); % function of p(t), Theta(t) and N(t)
        Ev(i,:) = ev_';
    end
    
    ev      = Pdfx*Ev;
    EV(:,h) = reshape( ev,xobs*pobs*Thobs*Nobs,1);
end