function outflow = flowbalance(Nt, Thetat, Thvec,Thobs,Nvec,Nobs,L0,  vhfitp,vffitp,Xhfitp,Xffitp,  xobs2,xobs,nobs, xgrid2,xgrid,ngrid,  transxmat2,h_xn,  mcons,felas)


tol = 1e-12;

%% Interpolate value functions @ Theta(t).
Thpos2= find( Thvec >Thetat,1,'first');
if isempty(Thpos2) ==1
    Thpos1 = Thobs -1;
    Thpos2 = Thobs;
else
    Thpos1 = max(1,Thpos2-1);
end
Thlo = Thvec(Thpos1);
Thhi = Thvec(Thpos2);
vh_T1= reshape( vhfitp(:,Thpos1,:,:), xobs,Nobs,nobs);
vh_T2= reshape( vhfitp(:,Thpos2,:,:), xobs,Nobs,nobs);
vf_T1= reshape( vffitp(:,Thpos1,:,:), xobs,Nobs,nobs);
vf_T2= reshape( vffitp(:,Thpos2,:,:), xobs,Nobs,nobs);
vhfitpT = vh_T1 + ((Thetat-Thlo)/(Thhi-Thlo +tol))*( vh_T2 -vh_T1);
vffitpT = vf_T1 + ((Thetat-Thlo)/(Thhi-Thlo +tol))*( vf_T2 -vf_T1);   

% and thresholds:
Xh_T1= reshape( Xhfitp(:,Thpos1,:), nobs, Nobs);
Xh_T2= reshape( Xhfitp(:,Thpos2,:), nobs, Nobs);
Xf_T1= reshape( Xffitp(:,Thpos1,:), nobs, Nobs);
Xf_T2= reshape( Xffitp(:,Thpos2,:), nobs, Nobs);
XhfitpT = Xh_T1 + ((Thetat-Thlo)/(Thhi-Thlo +tol))*( Xh_T2 -Xh_T1);
XffitpT = Xf_T1 + ((Thetat-Thlo)/(Thhi-Thlo +tol))*( Xf_T2 -Xf_T1);   




 %% Interpolate @ N(t).
Npos2= find( Nvec >Nt,1,'first');
if isempty(Npos2) ==1
    Npos1 = Nobs -1;
    Npos2 = Nobs;
else
    Npos1 = Npos2-1;
end
Nlo = Nvec(Npos1);
Nhi = Nvec(Npos2);
 % value functions 
vh_N1 = reshape(vhfitpT(:,Npos1,:), xobs,nobs);
vh_N2 = reshape(vhfitpT(:,Npos2,:), xobs,nobs);
vf_N1 = reshape(vffitpT(:,Npos1,:), xobs,nobs);
vf_N2 = reshape(vffitpT(:,Npos2,:), xobs,nobs);
vhfit = vh_N1 + ((Nt-Nlo)/(Nhi-Nlo))*( vh_N2 -vh_N1); % xobs by nobs.
vffit = vf_N1 + ((Nt-Nlo)/(Nhi-Nlo))*( vf_N2 -vf_N1);

 % thresholds
Xh_N1 = XhfitpT(:,Npos1);
Xh_N2 = XhfitpT(:,Npos2);
Xf_N1 = XffitpT(:,Npos1);
Xf_N2 = XffitpT(:,Npos2);
Xhfit = Xh_N1 + ((Nt-Nlo)/(Nhi-Nlo))*( Xh_N2 -Xh_N1);
Xffit = Xf_N1 + ((Nt-Nlo)/(Nhi-Nlo))*( Xf_N2 -Xf_N1);



 %% Fit policy rules to Enlarged productivity grid.
vhfit2 = spline(xgrid', vhfit', xgrid2); %nobs by xobs2.
vffit2 = spline(xgrid', vffit', xgrid2);
[~,posh] =  max(vhfit2); 
[~,posf] =  max(vffit2); 
nht  = ngrid(posh);
nft  = ngrid(posf);

[~,hro] = min(abs( ngrid*ones(1,xobs2) -ones(nobs,1)*nht')); %this finds element of ngrid that matches each nht
[~,fro] = min(abs( ngrid*ones(1,xobs2) -ones(nobs,1)*nft'));
hro = hro'; % xobs2 by 1
fro = fro';



 %% Simulate joint distribution
[~,~,~, ~, outflow] = jointxn(xobs2,xgrid2,nobs,ngrid,  transxmat2,  h_xn,  Xhfit,Xffit, nht,nft, hro,fro);

    
