function [Nt,Seps,Hires, hnew_xn,  outflow] = jointxn(xobs2,xgrid2,nobs,ngrid,  transxmat2,  h_xn,  Xh,Xf, nht,nft, hro,fro)
          
 %% Simulate joint distribution
tol = 1e-12;
outflow = zeros(1,nobs);
inflow  = zeros(xobs2,nobs);
hnew_xn = zeros(xobs2,nobs);
hires = zeros(nobs,1);
seps = zeros(nobs,1);
for i = 1:nobs
    nlag = ngrid(i);
    hindx= (xgrid2 >Xh(i));         % rows of xgrid2 s.t. firm with nlag will hire.
    findx= (xgrid2 <Xf(i));
    haux = transxmat2'*h_xn(:,i);	% integrates out x(t-1) --> p.d.f.(x(t) | n(t-1)), xobs2 by 1.
    hires(i) = sum( haux.*hindx.*(nht -nlag));
    seps(i)  = sum( haux.*findx.*(nlag-nft ));

    % Now fill in p.d.f(x(t), n(t)), that is, for each x
    % assign haux to a n. 
    % Remark  : given n(t-1) and x, the firm will 
    %           hire up to nh(x) [if x high enough]; 
    %           fire down to nf(x) [if x low enough]; 
    %           or stay put, n(t) = n(t-1). Thus,
    %           each element of haux can be 
    %           assigned to a unique n.
    % To this end, recall "hro" gives position of nh(x) on ngrid. 
    % So for x s.t. hindx==1, hro says where mass in haux 
    % should be assigned. Likewise for "fro".
    
    col = hindx.*hro + findx.*fro + (1-hindx).*(1-findx)*i;
    pos = (1:xobs2)' + (col-1)*xobs2;
    hnewi = zeros(xobs2,nobs);
    hnewi(pos) = haux;
    hnew_xn    = hnewi +hnew_xn;  
    
    
     % For flow-balance employment, save the flows.
    posn = hindx.*hro + findx.*fro;  
     % NOTE: If posn(i) = j >0 then firm with xgrid(i) moves to ngrid(j). 
    posx = find(posn >0);            
    posn = nonzeros(posn);    
    pos  = posx + (posn-1)*xobs2;
    infl = zeros(xobs2, nobs);
    infl(pos) = haux(posx);
    inflow = infl + inflow;  
     % prob(outflow):
    outflow(i) = sum(haux(posx)) /(tol +sum(haux)); % sum(haux) is mass of firms w/ n_-1
 
end
hn = sum(hnew_xn);
Nt = hn*ngrid;
Seps =sum(seps);
Hires=sum(hires);

