function [nh,nf, v_no,v_adjh,v_adjf, vtomaxh,vtomaxf,  Xh,Xf] = policyss(beta,alpha,prodconst,  xobs,xgrid,xweights,Stdev_epsx,rhox,mux,   nobs,ngrid,  Omega0,HireCost0,FireCost0, pt)
                                        


ch     = (1-beta)*HireCost0; %annuitized cost
cf     = (1-beta)*FireCost0;


%% Initialize with static model
% Don't adjust:
xmat   = xgrid * ones(1,nobs);
nmat   = ones(xobs,1) * ngrid';             
profit_no  = prodconst*pt*xmat.*(nmat.^alpha)  -  Omega0*nmat;  
% this is profit after subst. for static wage and rearranging

% Adjust UP:
profit     = prodconst*pt*xmat.*(nmat.^alpha)  -  Omega0*nmat  - ch*nmat;
[maxprof, pos] = max(profit, [], 2);
nh_m = ngrid(pos);
Nh_m = nh_m*ones(1,nobs);
profit_adjh = maxprof*ones(1,nobs)+ ch*ones(xobs,1)*ngrid';

% Adjust DOWN:
profit     = prodconst*pt*xmat.*(nmat.^alpha)  -  Omega0*nmat  + cf*nmat;
[maxprof, pos] = max(profit, [], 2);
nf_m = ngrid(pos);
Nf_m = nf_m*ones(1,nobs);
profit_adjf = maxprof*ones(1,nobs)- cf*ones(xobs,1)*ngrid';


% for later,
profith    = prodconst*pt*xmat.*(nmat.^alpha)  -  Omega0*nmat  - HireCost0*nmat;
profitf    = prodconst*pt*xmat.*(nmat.^alpha)  -  Omega0*nmat  + FireCost0*nmat;


%% Start value iteration
v_adjh = profit_adjh; 
v_adjf = profit_adjf; 
v_no   = profit_no;   
V_adjh = v_adjh.*(Nh_m >nmat) - 10e6*(Nh_m <=nmat);
V_adjf = v_adjf.*(Nf_m <nmat) - 10e6*(Nf_m >=nmat);
v0     = max( [reshape(V_adjf,xobs*nobs,1),  ...
               reshape(v_no,  xobs*nobs,1),  ...
               reshape(V_adjh,xobs*nobs,1)], [],2 );
v0     = reshape( v0, xobs,nobs );
nh     = nh_m;
nf     = nf_m;
nh0    = nh;
nf0    = nf;

 % Transition matrix (for use below)
xnext  = ones(xobs,1)*xgrid';
xnow   = xgrid       *ones(1,xobs);
elogx  = mux + rhox*log(xnow);
Fxmax  = normcdf((log(xgrid(xobs))-elogx)/Stdev_epsx);
Fxmin  = normcdf((log(xgrid(1   ))-elogx)/Stdev_epsx);
pdfx   = (1./(xnext*Stdev_epsx*sqrt(2*pi))) .* exp(-0.5*( ((log(xnext)   -elogx)/Stdev_epsx).^2 ));
pdfx   = pdfx ./ (Fxmax -Fxmin);
xwght  = ones(xobs,1)*xweights';
Pdfx   = xwght .* pdfx;
Sumpdfx= sum(Pdfx, 2);
Pdfx   = Pdfx ./ repmat(Sumpdfx, 1, xobs);


iter   = 0;
ptol   = 0.005;
perrcount  = 0;
while perrcount <=5 
    
    %% Compute E[v].
    EV      = Pdfx*v0; 
      
    %% Update:
    vtomaxh = profith   + beta*EV;
    vtomaxf = profitf   + beta*EV;
     % HIRING:
    [vmaxh , pos]= max(vtomaxh,[],2);  
    nh     = ngrid(pos);
    v_adjh = vmaxh*ones(1,nobs) + HireCost0*ones(xobs,1)*ngrid'; %add back in lagged n
     % FIRING
    [vmaxf, pos]= max(vtomaxf,[],2);  
    nf     = ngrid(pos);
    v_adjf = vmaxf*ones(1,nobs) - FireCost0*ones(xobs,1)*ngrid'; 
     % INACTION
    v_no   = profit_no + beta*EV;
     
     % Update v:
    Nh     = nh*ones(1,nobs);
    Nf     = nf*ones(1,nobs);
    V_adjh = v_adjh.*(Nh >nmat) - 10e6*(Nh <=nmat);
    V_adjf = v_adjf.*(Nf <nmat) - 10e6*(Nf >=nmat);
    v      = max( [reshape(V_adjf,xobs*nobs,1), ...
                   reshape(v_no,  xobs*nobs,1), ...
                   reshape(V_adjh,xobs*nobs,1)], [],2 );
    v      = reshape( v, xobs,nobs );
    
    % Value and policy errors
    iter   = iter +1;
    verr   = max(max(abs( v-v0)));
    perr_h = max( max(abs(nh-nh0)) );
    perr_f = max( max(abs(nf-nf0)) );
    perr   = max( [ perr_h,perr_f] );
    perrcount = (perr <ptol).*(perrcount +1);
    disp('Iteration and value and policy errors');
    disp( [iter,  verr,  perr, perrcount] );
    
    % reset
    nh0 = nh;
    nf0 = nf;
    v0  = v;
end



 %% Productivity thresholds (see policysearch for annotations)
xstep    = .01;
longx    = (xgrid(1) :xstep: xgrid(xobs))';  
if longx(end) <xgrid(xobs)
    longx= [longx; ...
            xgrid(xobs)];
end
longxobs = length(longx);

vhfit   = spline(xgrid',vtomaxh',longx); % nobs by longxobs
vffit   = spline(xgrid',vtomaxf',longx);
[~,posh] = max(vhfit);
[~,posf] = max(vffit);
nhlong= ngrid(posh);
nflong= ngrid(posf);
 
 
tol = 1e-8;
nhmat = nhlong * ones(1,nobs);
nfmat = nflong * ones(1,nobs);
nt    = ones(longxobs,1)*ngrid';

%% HIRING
[~,pos2] = max((nhmat-nt - tol) .* (nhmat<=nt)); % minus tol so pos2 will pick first element where nh >nt (strictly).
pos2 = pos2';
pos1 = max(1, pos2-1);
x1   = longx(pos1);
x2   = longx(pos2);
dn   = nhmat - nt; % dn is xobs by nobs. For given n, a function of x.
dn1  = dn( pos1 + ((1:1:nobs)' -1)*longxobs );
dn2  = dn( pos2 + ((1:1:nobs)' -1)*longxobs );
 % threshold solves 0 = dn1 + ((threshold-x1) /(x2-x1))*( dn2 - dn1 ) -->
xh   = x1 - ((x2-x1).*(dn1./(dn2-dn1+tol)));
 % NOTE: If nh never reaches nt, then should set pos2=xobs (xh = max{x}).
Xh   = xh.*(dn2 >0) + xgrid(xobs).*(dn2 <=0);


%% FIRING
[~,pos2] = max((nfmat-nt) .* (nfmat< nt));	% pos2 will be first point where nf >=nt
pos2 = pos2';
pos1 = max(1, pos2-1);
x1   = longx(pos1);
x2   = longx(pos2);
dn   = nfmat - nt;
dn1  = dn( pos1 + ((1:1:nobs)' -1)*longxobs );
dn2  = dn( pos2 + ((1:1:nobs)' -1)*longxobs );
xf   = x1 - ((x2-x1).*(dn1./(dn2 - dn1 +tol)));
Xf   = xf.*(dn2>=0) + xgrid(xobs).*(dn2 <0); % if dn2 < (strictly) 0, then always fire.
 
 