*Calculate flows data created from QCEW microdata in "Main.sas"

clear all
set more off
cd "path"
insheet using adjustprobdataset.csv, clear

#delimit ;
reshape long totadjustdown totadjustup totadjustin
		totadjust totadjustinup totadjustindown numestabs1 numestabs2 dist1 dist2, i(binlst) j(yrqrt);
rename dist1 h1;
rename dist2 h2;
drop *f*;
sort yrqrt binlst;

gen phi=totadjust;
gen tau=totadjustin;

*25 and 75 percentile;
gen sizeclass=.;
replace sizeclass=1 if binlst<=15;
replace sizeclass=2 if binlst>15 & binlst<=170;
replace sizeclass=3 if binlst>170;

collapse phi tau (rawsum) h1 [aw=h1], by(yrqrt sizeclass);
reshape wide phi tau h1, i(yrqrt) j(sizeclass);
gen phi0=phi1*h11+phi2*h12+phi3*h13;
gen tau0=tau1*h11+tau2*h12+tau3*h13;

sort yrqrt;
gen qdate=tq(1990q2)+_n-1;
tsset qdate, q;

save flowdata, replace;
