*Seasonally adjust actual and flow balance employment to create Figure 7
clear all
set more off

#delimit ;
use "/path/BLS code/FlowBalance.dta", replace;

keep if qdate>=tq(1992q2);
local salist="totalemp_act totalemp_hat";

keep qdate `salist';

foreach var of local salist{;
  rename `var' `var'_n;
};
save flowbalance_n, replace;

foreach var of local salist{;
  rename `var'_n `var';
};
gen int year = year(dofq(qdate));
gen byte qrt = quarter(dofq(qdate));
cd sa;

file open metafile using metafile.dta, write text replace;
foreach var of local salist {;
  outfile year qrt `var' using `var'.dat, nolabel replace;
  file write metafile _char(034)"`var'.dat"_char(034) _n;
};
file close metafile;
shell x12a-0.3 stocks-q -d metafile;
!cat metafile.log >> seasadj-s.log;
foreach var of local salist {;
  infix 3 first int year 1-4 byte qrt 5-6 double `var' 10-35 using `var'.d11, clear;
  gen int qdate = yq(year,qrt);
  keep qdate `var';
  tsset qdate, q;
  compress;
  save `var'.dta, replace;
  erase `var'.dat;
  erase `var'.err;
  erase `var'.d11;
};
erase metafile.dta;
erase metafile.log;
cd ..;


use flowbalance_n, clear;
foreach var of local salist{;
  merge 1:1 qdate using ./sa/`var', nogen;
};

drop *_n;
foreach var of varlist totalemp_act totalemp_hat{;
replace `var'=log(`var');
qui reg `var' c.qdate##c.qdate;
predict `var'_qdt, resid;
replace `var'=exp(`var');

};
save flowbalance, replace;

keep qdate totalemp_act_qdt totalemp_hat_qdt;
export excel Figure7.xlsx, firstrow(variables) replace sheet("Employment, quad detrend") datestring("%tq");

