*Seasonally adjust flows data and detrend
clear all
set more off

#delimit ;
use "/path/BLS code/flowsdata", replace;

keep if qdate>=tq(1992q2);
local salist="phi0 phi1 phi2 phi3 tau0 tau1 tau2 tau3";

keep qdate `salist';

foreach var of local salist{;
  rename `var' `var'_n;
};
save flows_n, replace;

foreach var of local salist{;
  rename `var'_n `var';
};
gen int year = year(dofq(qdate));
gen byte qrt = quarter(dofq(qdate));
cd sa;

file open metafile using metafile.dta, write text replace;
foreach var of local salist {;
  outfile year qrt `var' using `var'.dat, nolabel replace;
  file write metafile _char(034)"`var'.dat"_char(034) _n;
};
file close metafile;
shell x12a-0.3 stocks-q -d metafile;
!cat metafile.log >> seasadj-s.log;
foreach var of local salist {;
  infix 3 first int year 1-4 byte qrt 5-6 double `var' 10-35 using `var'.d11, clear;
  gen int qdate = yq(year,qrt);
  keep qdate `var';
  tsset qdate, q;
  compress;
  save `var'.dta, replace;
  erase `var'.dat;
  erase `var'.err;
  erase `var'.d11;
};
erase metafile.dta;
erase metafile.log;
cd ..;


use flows_n, clear;
foreach var of local salist{;
  merge 1:1 qdate using ./sa/`var', nogen;
};

drop *_n;
foreach var of varlist phi* tau*{;
replace `var'=log(`var');
qui reg `var' c.qdate##c.qdate;
predict `var'_qdt, resid;
replace `var'=exp(`var');

};
save flows, replace;

preserve;
keep phi0-tau3;
outsheet using flows_sa.txt, replace nonames;
restore;
preserve;
keep *qdt;
outsheet using flows_qdt.txt, replace nonames;

