%Estimates IRFs from equations 24-25 and used in Figure 10C and 10E;
%The variables phi1 - phi3 (columns 2-4 in the output file) are the outflows in Figure 10C;
%The variables tau1 - tau3 (columns 6-8 in the output file) are the total inflows in Figure 10E;

clear; clc;close all;
datamat = dlmread('RawData.txt');
prod_emp = datamat(:,3); %output per emp

data2 = dlmread('flows_sa.txt');
phi0=log(data2(:,1));
phi1=log(data2(:,2));
phi2=log(data2(:,3));
phi3=log(data2(:,4));
tau0=log(data2(:,5));
tau1=log(data2(:,6));
tau2=log(data2(:,7));
tau3=log(data2(:,8));
data2=log(data2);

df=[prod_emp];
for zzzz=1:8;
series=data2(:,zzzz);    

    
%% I) AR(4) in output
output = df(:,1);                      
p=4;
intercept=1;
y=output(p+1:end,:);
ydm=y-mean(y);

X1=[];
X2=[];
for i=1:p;
    X1=[X1 output(p+1-i:end-i,:)];
    X2=[X2 emp(p+1-i:end-i,:)];
end;
time=[1:length(X2)]';
X=[X1 X2 time time.^2];
Xdm=X-repmat(mean(X,1),length(X),1);
[bhat_y,~,~,~,yres,bhat_y_cov]=OLS(ydm,[Xdm]);
ypred=ydm-yres;

%% II) AR model of series

y_series=[series(2*p:end,:)];
X1_series=[];
X2_series=[];
for i=1:p;
    X1_series=[X1_series series(2*p-i:end-i,:)];
    X2_series = [X2_series yres(p-i+1:end-i+1,:)];
end;
time=[1:length(X2_series)]';
X_series=[X1_series X2_series time time.^2];    

X_series=X_series-repmat(mean(X_series,1),length(X_series),1);
y_series=y_series-mean(y_series);
[bhat_series,~,~,~,nres2,bhat_series_cov]=OLS(y_series,X_series);

T=25;
irfy=zeros(T+p,1);
irfseries=zeros(T+p,1);

yeps=zeros(T+p,1);
yeps(p+1,1)=.01;

xvec=[irfseries(1:p)' yeps(1:p)'];
yvec=[irfy(1:p)'];

for i=p+1:T+p;
        irfseriesvec=[];
    for j=1:p;
        irfseriesvec=[irfseriesvec irfseries(i-j)];
    end;

xvec=[irfseriesvec];
for j=1:p;    
xvec=[xvec yeps(i-j+1)]; 
end;
xvec=[xvec 0 0]; 
irfseries(i)=xvec*bhat_series;

end;
irfmat(:,zzzz)=[irfseries];


end;
irfmat=irfmat(5:16,:);
dlmwrite('Flow_IRFs.txt',100*irfmat);
