function [nh,nf, v_no,v_adjh,v_adjf, vtomaxh,vtomaxf,EV] = policylinearconvexdiscretess(alpha,beta,  xobs,xgrid,Stdev_epsx,rhox,mux,   nobs,ngrid,xweights,  eta,Omega0,prodconst,HireCost0, FireCost0,conc,cone)
dbstop if error


%% Initialize: Guess static policy rules.
 % Some parameters you will want in order to initialize:
alpha2 = alpha*(1-eta)/(1-eta*(1-alpha));
ch0    = (1-beta*(1-.025))*HireCost0; 
cf0    = (1-beta*(1-.025))*FireCost0; 

xmat   = repmat(xgrid * ones(1,nobs),[nobs 1]);
nch   = ones(xobs*nobs,1) * ngrid';             
nmat   = repmat(kron(ngrid,ones(xobs,1)),[1 nobs]);
nlag   = kron(ngrid,ones(xobs,1));

% Don't adjust:
profit_no  = prodconst*xmat(:,1).*(nlag.^alpha)  -  Omega0*nlag;  

% Adjust UP
profit_adjh1 = prodconst*xmat.*(nch.^alpha) -  Omega0*nch  - HireCost0*(nch-nmat).*(nch >nmat) - (conc)*abs(nch - nmat).^cone; 
[profit_adjh,npos]   = max(profit_adjh1,[],2);
Nh_m  = ngrid(npos);

% Adjust DOWN:           
profit_adjf1 = prodconst*xmat.*(nch.^alpha)  -  Omega0*nch  - FireCost0*(nmat-nch).*(nch <nmat) - (conc)*abs(nch - nmat).^cone;
[profit_adjf,npos]   = max(profit_adjf1,[],2);
Nf_m  = ngrid(npos);


%% Start value iteration
v_adjh = profit_adjh; 
v_adjf = profit_adjf; 
v_no   = profit_no;   
V_adjh = v_adjh.*(Nh_m >nlag) - 10e4*(Nh_m <=nlag);
V_adjf = v_adjf.*(Nf_m <nlag) - 10e4*(Nf_m >=nlag);
v0     = max( [V_adjf, v_no, V_adjh],[], 2);
v_adjh = reshape(v_adjh,[xobs nobs]);
v_adjf = reshape(v_adjf,[xobs,nobs]);
v_no   = reshape(v_no,[xobs,nobs]);
v0     = reshape( v0, xobs,nobs );

nh     = reshape(Nh_m,[xobs,nobs]); % initial policies are myopic ("m") policies
nf     = reshape(Nf_m,[xobs,nobs]);
nh0    = nh;
nf0    = nf;

% For use in optimization,
profith    =  prodconst*xmat.*(nch.^alpha)  -  Omega0*nch  - HireCost0*nch - (conc)*abs(nch - nmat).^cone ;
profitf    =  prodconst*xmat.*(nch.^alpha)  -  Omega0*nch  + FireCost0*nch - (conc)*abs(nch - nmat).^cone;
profit_no  = prodconst*xmat(:,1).*(nlag.^alpha)  -  Omega0*nlag;  
iter   = 0;
ptol   = 0.005;
perrcount  = 0;
while perrcount <5 % will stop when max policy error is < "ptol" for "perrcount" number of times.
    
    %% Iterate forward: for given v, compute E[v].
    EV     = evfunlinearconvexss(nobs,xobs,xgrid,ngrid,xweights,  nf,nh,v_no,v_adjh,v_adjf,  mux,rhox,Stdev_epsx);
    EV_a     = repmat(EV,[nobs 1]);
    EV_no    = reshape(EV,[nobs*xobs 1]);
    %% Update:
    vtomaxh = profith   + beta*EV_a;
    vtomaxf = profitf   +  beta*EV_a;
     % HIRING:
    [vmaxh , pos]= max(vtomaxh,[],2);  
    nh     = ngrid(pos);
    v_adjh = vmaxh + HireCost0*nlag; %add back in adj cost 
     % FIRING
    [vmaxf, pos]= max(vtomaxf,[],2);  
    nf     = ngrid(pos);
    v_adjf = vmaxf - FireCost0*nlag; 
    
     % Reset:
    v_no   = profit_no + beta*EV_no;
    Nh     = nh;
    Nf     = nf;
    V_adjh = v_adjh.*(Nh >nlag) - 10e6*(Nh <=nlag);
    V_adjf = v_adjf.*(Nf <nlag) - 10e6*(Nf >=nlag);
    [v,pos]      = max( [V_adjf, v_no, V_adjh], [],2 );
    v      = reshape( v, xobs,nobs );
    nh     = reshape(Nh,[xobs nobs]);
    nf     = reshape(Nf,[xobs nobs]);
    v_adjh = reshape(v_adjh, [xobs nobs]);
    v_adjf = reshape(v_adjf, [xobs nobs]);
    v_no   = reshape(v_no,   [xobs nobs]);
    nmax = reshape((pos==1).*Nf + (pos==2).*nlag + (pos==3).*Nh,[xobs nobs]);
    % Compare:
    iter   = iter +1;
    verr   = max(max(abs( v-v0)));
    perr_h = max( max(abs(nh-nh0)) );
    perr_f = max( max(abs(nf-nf0)) );
    perr   = max( [ perr_h,perr_f] );
    disp('Iteration,  dV,    max{dhiring,dfiring}');
    disp( [iter,      verr,  perr] );
    perrcount = (perr <ptol).*(perrcount +1);
    nh0 = nh;
    nf0 = nf;
    v0  = v;
end






