function EV = evfunlinearconvex(nobs,xobs,xgrid,ngrid,xweights,  pobs,pgrid,Ptrans,  nf,nh,v0,v_no,v_adjh,v_adjf,  mux,rhox,Stdev_epsx)


xnext  = ones(xobs,1)*xgrid';
xnow   = xgrid       *ones(1,xobs);
elogx  = mux + rhox*log(xnow);
Fxmax  = normcdf((log(xgrid(xobs))-elogx)/Stdev_epsx);
Fxmin  = normcdf((log(xgrid(1   ))-elogx)/Stdev_epsx);
pdfx   = (1./(xnext*Stdev_epsx*sqrt(2*pi))) .* exp(-0.5*( ((log(xnext)   -elogx)/Stdev_epsx).^2 ));
pdfx   = pdfx ./ (Fxmax -Fxmin);
xwght  = ones(xobs,1)*xweights';
Pdfx   = xwght .* pdfx;

%First integrate over p
EVp = Ptrans*v0;

%Now integrate over x
EVp = reshape(EVp,[pobs xobs nobs]);
EVp = reshape(permute(EVp,[2 1 3]),[xobs pobs*nobs]);
EVx = Pdfx*EVp;
EVx = reshape(EVx,[xobs pobs nobs]);
EV = reshape(permute(EVx,[2 1 3]),[pobs xobs*nobs]);

